<?php

class formWidgetContentRandomOptions extends cmsForm {

    public function init($options=false) {

		$fields_list = array(''=>'');
		
		if (!empty($options['ctype_id'])){
			$content_model = cmsCore::getModel('content');	
			$ctype = $content_model->getContentType($options['ctype_id']);
			
			$fields = $content_model->getContentFields($ctype['name']);
			if ($fields){ $fields_list = array(''=>'') + array_collection_to_list($fields, 'name', 'title'); }					
			
		}

        return array(

            array(
                'type' => 'fieldset',
                'title' => LANG_OPTIONS,
                'childs' => array(

                    new fieldList('options:ctype_id', array(
                        'title' => LANG_CONTENT_TYPE,
                        'generator' => function($item) {

                            $model = cmsCore::getModel('content');
                            $tree = $model->getContentTypes();

                            $items = array();

                            if ($tree) {
                                foreach ($tree as $item) {
                                    $items[$item['id']] = $item['title'];
                                }
                            }

                            return $items;

                        }
                    )), 
                            
                    new fieldList('options:image_field', array(
                        'title' => LANG_WD_CONTENT_RANDOM_IMAGE,
						'parent' => array(
							'list' => 'options:ctype_id',
							'url' => href_to('content', 'widget_fields_ajax')
						),
						'items' => $fields_list
                    )),

                    new fieldList('options:teaser_field', array(
                        'title' => LANG_WD_CONTENT_RANDOM_TEASER,
						'parent' => array(
							'list' => 'options:ctype_id',
							'url' => href_to('content', 'widget_fields_ajax')
						),
						'items' => $fields_list
                    )),
                            
                    new fieldNumber('options:teaser_max_length', array(
                        'title' => LANG_WD_CONTENT_RANDOM_TEASER_MAX_LENGTH,
                        'hint' => LANG_WD_CONTENT_RANDOM_TEASER_MAX_LENGTH_HINT,
                        'default' => 0,
                        'units' => LANG_WD_CONTENT_RANDOM_TEASER_MAX_LENGTH_UNITS
                    )),
                            
                    new fieldNumber('options:amount_items', array(
                        'title' => LANG_WD_CONTENT_RANDOM_AMOUNT_ITEMS,
                        'default' => 1,
                        'rules' => array(
                            array('required')
                        )
                    )),

                    new fieldCheckbox('options:show_details', array(
                       'title' =>  LANG_WD_CONTENT_RANDOM_DETAILS,
                    )),

                )
            ),

        );

    }

}
