<?php

class widgetContentRandom extends cmsWidget {

    public function run(){

        $ctype_id = $this->getOption('ctype_id');
        $image_field = $this->getOption('image_field');
        $teaser_field = $this->getOption('teaser_field');
        $teaser_max_length = $this->getOption('teaser_max_length');
        $amount_items = $this->getOption('amount_items');
        $is_show_details = $this->getOption('show_details');

        $model = cmsCore::getModel('content');

        $ctype = $model->getContentType($ctype_id);

        if (!$ctype) { return false; }

        // Отключаем фильтр приватности для тех кому это разрешено
        if (cmsUser::isAllowed($ctype['name'], 'view_all')) {
            $model->disablePrivacyFilter();
        }

        // Скрываем записи из скрытых родителей (приватных групп и т.п.)
        $model->filterHiddenParents();        

        $total = $model->getContentItemsCount($ctype['name']); 
        if ($total<=0) { return false; } 
        if ((int)$amount_items>=$total && (int)$amount_items!=1) { $amount_items = $total-1; }
        
        $all_items = $model->getContentItems($ctype['name']);
        shuffle($all_items);
        $items = array_slice($all_items, $item_id, (int)$amount_items); 
        
        $this->links = LANG_WD_CONTENT_RANDOM_REFRESH . '| #refresh" id="rnd_refresh_'.$this->id.'" onclick="icms.random.getNext('.$this->id.'); return false' ;

        if (!$items) { return false; }
        
        shuffle($items);

        return array(
            'ctype' => $ctype,
            'image_field' => $image_field,
            'teaser_field' => $teaser_field,
            'teaser_max_length' => (int)$teaser_max_length,
            'amount_items' => (int)$amount_items,
            'is_show_details' => $is_show_details,
            'items' => $items, 
        );

    }

}
