var icms = icms || {};

icms.random = (function ($) {

    //=====================================================================//

    this.getNext = function(widget_id) {

        var ref_link = $('#rnd_refresh_'+widget_id);
        ref_link.hide();
        ref_link.parent().append('<div id="loading_'+widget_id+'" class="loading">&nbsp;</div>');       
        
        var rnd_data = $('#rnd_data_'+widget_id);
        var r_data = {
            widget_id:          widget_id,
            item_id:            rnd_data.data('item-id'),
            ctype_name:         rnd_data.data('ctype-name'),
            amount_items:       rnd_data.data('amount-items'),
            image_field:        rnd_data.data('image-field'),
            teaser_field:       rnd_data.data('teaser-field'),
            teaser_max_length:  rnd_data.data('teaser-max-length'),
            is_comments:        rnd_data.data('is-comments')
        }

        var url = rnd_data.data('url');

        $.post(url, r_data, icms.random.updateData, "json");

        return false;

    }

    //=====================================================================//

    this.updateData = function(result){
        
        if (result == null || typeof(result) == 'undefined' || result.error){
                icms.random.error(result.message);
                return;
            }
            
        var rnd_item = $('#content-random-'+result.widget_id+' .rnd_item');    

        rnd_item.each(function(indx, item){
            $('a', $(item)).attr('href', result.items[indx].url);
        
            if ((pos = result.items[indx].image.indexOf('http:')) > -1) {
                $('.rnd_image a', $(item)).html(result.items[indx].image);
                $('.rnd_image', $(item)).css({ "height" : "" });
            } else {
                $('.rnd_image a', $(item)).html('');
                $('.rnd_image', $(item)).css({ "height" : "0" });
            }

            $('.title a', $(item)).text(result.items[indx].title);
            $('.info .rnd_teaser', $(item)).text(result.items[indx].teaser_text);
            $('.info .author', $(item)).html('<a href="' + result.items[indx].url_author + '">' + result.items[indx].author + '</a>' );
            $('.info .date', $(item)).text(result.items[indx].date);
            $('.info .comments a', $(item)).attr('href', result.items[indx].url+'#comments');
            $('.info .comments a', $(item)).text(result.items[indx].comments);
        });
        
        $('#rnd_data_'+result.widget_id).data('item-id', result.items[0].id).attr('data-item-id', result.items[0].id);
        
        icms.random.restoreForm(result.widget_id);

    }
    
    //=====================================================================//

    this.error = function(message){
        alert(message);
        this.restoreForm();
    }
    
    //=====================================================================//
    
    this.restoreForm = function(widget_id){
        
        $('#loading_'+widget_id).remove();
        $('#rnd_refresh_'+widget_id).show();
    }
    
    //=====================================================================//
    
    this.smartColumns = function(widget_id){ //функция, подсчитывающая ширину колонок

        var sm_col = $("#content-random-"+widget_id+" ul.column");
	//сброс ширины строки до 100% после изменения размера экрана
	sm_col.css({ "width" : "100%"});

	var colWrap = sm_col.width(); //определяем ширину строки
	var colNum = Math.floor(colWrap / 200); //определяем, сколько столбцов в 200px вместится в строку и округляем число до целого
	var colFixed = Math.floor(colWrap / colNum); //ширину строки делим на количество столбцов, округляем до целого числа, в результате получаем точную скорректированную ширину колонки
        
	sm_col.css({ 'width' : colWrap}); //ставим точную ширину строки в пикселях вместо использования % - это предотвратит возможные баги в разных браузерах при различных разрешениях экрана
	$("li", sm_col).css({ "width" : colFixed}); //ставим точную ширину измененным столбцам
        
        $("li:nth-child("+colNum+"n) .rnd_item", sm_col).css({ "margin-right" : "0"});
        
        $("li:gt(-"+(colNum+1)+")", sm_col).css({ "margin-bottom" : "0"});
        
    }

	return this;

}).call(icms.random || {},jQuery);
